stages:
  - push

variables:
  OCI_REGISTRY_URL: ${CI_REGISTRY_IMAGE}
  OCI_REGISTRY_USER: ${CI_REGISTRY_USER}
  OCI_REGISTRY_PASS: ${CI_REGISTRY_PASSWORD}
  CHARTS_DIR: _charts
  
push:
  stage: push
  image:
    name: alpine/helm:3.15.2
    entrypoint: [""]
  before_script:
    - echo ${OCI_REGISTRY_PASS} | helm registry login -u ${OCI_REGISTRY_USER} ${OCI_REGISTRY_URL} --password-stdin
  script:
    - echo "Building Helm charts..."
    - |
      mkdir ready_charts
      for file in $(find ./${CHARTS_DIR} -type f -name "Chart.yaml"); do
        dir=$(dirname "$file")
        helm dependency update "$dir"
        helm lint "$dir"
        helm package "$dir" -d ready_charts
        echo "-----------------------------------------------"
      done
    - echo "Pushing Helm charts to the OCI repository..."
    - |
      for file in $(find ./ready_charts -type f -name "*.tgz"); do
        dir=$(dirname "$file")
        helm push $file oci://${OCI_REGISTRY_URL}/charts;
      done
      rm -rf ready_charts
